#!/bin/bash

if [ -n "$TRAVIS_TAG"]; then
	echo "No TAG provided"
else
	echo "         "
	echo "-----------------------------------"
	echo "$TRAVIS_TAG"
	echo "-----------------------------------"

	IFS='.' read -r -a array <<< "$TRAVIS_TAG"

	re='^[0-9]+$'

	i=0
	for element in "${array[@]}"
	do
		if [[ $element =~ $re ]] ; then
	   		parts[$i]=$element
	   		i=$((i+1))
		fi
	done

	size=${#parts[@]}

	if [[ size -le 4  && size -ge 3 ]]; then
		if [[ "$size" -ge 3 ]]; then
			major=${parts[0]}
			minor=${parts[1]}
			patch=${parts[2]}
			if [[ "$size" -eq 4 ]]; then
				build=${parts[3]}
			fi

			rm version.properties
			touch version.properties
			echo "#Autogenerated version file" >> version.properties
			echo "VERSION_MAJOR=$major" >> version.properties
			echo "VERSION_MINOR=$minor" >> version.properties
			echo "VERSION_PATCH=$patch" >> version.properties

			cat version.properties
			exit 0
		fi
		exit 1
	else
		echo "Uncompatible number of items min(3) max(4): $TRAVIS_TAG"
		exit 1
	fi
fi

